#include "toshset.h"

pair<string,int> Mapair[MAXN];

clock_t Wbybin_N(const string pairstr[],const int pairint[],const string toslove[]){
	int *sloved=new int[MAXN];
    clock_t starts=clock(),ends;
    for (int i=0;i<MAXN;++i)
        Mapair[i]=make_pair(pairstr[i],pairint[i]);
    sort(Mapair,Mapair+MAXN);
    for (int i=0;i<MAXN/2;++i){
        int low=0,high=MAXN-1,flag=0;
        while (low<=high){
            int mid=(low+high)>>1;
            if (Mapair[mid].first==toslove[i]){
                sloved[i]=Mapair[mid].second;
                flag=1;
            }else if (Mapair[mid].first>toslove[i]){
                high=mid-1;
            }else low=mid+1;
            if (flag)
                break;
        }
    }
    /*cout<<"-------------------------------------------------------------------------------"<<endl;
    for (int i=0;i<100;++i)
        cout<<pairstr[i]<<"->"<<sloved[i]<<endl;*/
    ends=clock();
    delete[] sloved;
    return ends-starts;
}

clock_t Wbybin_Y(const string pairstr[],const int pairint[],const string toslove[]){
	int *sloved=new int[MAXN];
    clock_t starts=clock(),ends;
    for (int i=0;i<MAXN;++i)
        Mapair[i]=make_pair(pairstr[i],pairint[i]);
    sort(Mapair,Mapair+MAXN);
    for (int i=0;i<MAXN/2;++i)
        sloved[i]=WbybinY_real(0,MAXN-1,toslove[i]);
    /*cout<<"-------------------------------------------------------------------------------"<<endl;
    for (int i=0;i<100;++i)
        cout<<pairstr[i]<<"->"<<sloved[i]<<endl;*/
    ends=clock();
    delete[] sloved;
    return ends-starts;
}

int WbybinY_real(int l,int r,const string& skey){
    int mid=(l+r)>>1;
    if (Mapair[mid].first==skey)
        return Mapair[mid].second;
    if (Mapair[mid].first>skey)
        return WbybinY_real(l,mid-1,skey);
    else return WbybinY_real(mid+1,r,skey);
}
